//
//  CatFilterUtils.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 26.09.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//My own filters
#import "SimpleMixFilter.h"
#import "ColorOverlayFilter.h"
#import "FastZoomFilter.h"


@interface FilterUtils : NSObject 
{
	NSMutableDictionary* filtersByID;

	//Shared standard filters
	CIFilter *fError;
	CIFilter *fWhite;
	CIFilter *fBlack;
	CIFilter *fTransp;

	CIColor *transp; 
	CIColor *white; 
	CIColor *black;
	
	
}

-(void) fillAccu:(CIImageAccumulator*)accu withColor:(CIColor*)col;


-(CIImage*) getImage:(CIImage*)inputImage  onBack:(CIImage*)backImg   withMask:(CIImage*)lMask andCacheID: (NSString*) idFilter;
	
-(CIImage*) getImage:(CIImage*)img onBack:(CIImage*)backImg
		withBlendMode: (NSString*) blendMode andOpacity: (float)opacity andCacheID: (NSString*) idFilter;

-(CIFilter*) getImageAsFilter:(CIImage*)img onBack:(CIImage*)backImg
		withBlendMode: (NSString*) blendMode andOpacity: (float)opacity andCacheID: (NSString*) idFilter;


-(CIImage*) getImage:(CIImage*) bgImage withOverlayedMask:(CIImage*)maskImage andColor:(NSColor*) c
	andCacheID: (NSString*) idOverFilter;

-(CIImage*) getImage:(CIImage*)srcImage offsetByPoint:(CGPoint)off invertOffset:(BOOL) invertOffset 	andCacheID: (NSString*) idCropFilter;
-(CIImage*) getImage:(CIImage*)src onBack:(CIImage*)back andCacheID:(NSString*)filterID;
-(CIImage*) getImage:(CIImage*)inputImage croppedToRect:(CGRect)r 	andCacheID: (NSString*) idCropFilter;

-(CIColor*) getCIColorFromNSColor:(NSColor*) ncol forceAlpha:(float)forceAlpha;
	

-(CIImage*) getGrayCIImage:(CIImage*)src andCacheID:(NSString*)filterID ;
//-(CIFilter*) getImageAsFilter:(CIImage*)src ;
-(CIFilter*) getImageAsFilter:(CIImage*)src andCacheID:(NSString*)idFilter;
-(CIImage*) getImage:(CIImage*) img  withLayerMask:(CIImage*)lMask 	andCacheID: (NSString*) idFilter;
-(CIImage*) getScaledImage:(CIImage*) cimg atRatio:(float) ratio 	andCacheID: (NSString*) idFilter;
-(CIImage*) getScaledAffineImage:(CIImage*)src atScaleX:(float)scaleX andScaleY:(float)scaleY withOffset:(CGPoint)pt andCacheID:(NSString*)idFilter;



-(CIImage*) getImageWhite;
-(CIImage*) getImageBlack;
-(CIImage*) getImageTransp;
-(CIImage*) getImageError;

-(CIFilter*) getFilterWhite;
-(CIFilter*) getFilterBlack;
-(CIFilter*) getFilterTransp;
-(CIFilter*) getFilterError;

-(CIColor*)getColorWhite;
-(CIColor*)getColorBlack;
-(CIColor*)getColorTransp;

-(CIImage*) getImageThumbnail:(CIImage*) image inRect:(CGRect)r
	onCheckers:(BOOL)onCheckers
	andCacheID: (NSString*) idFilter;
-(CIImage*) verifyImage:(CIImage*) inputImage fromCmd:(NSString*)cmdName;

@end
